{ $Define Debug}
Unit OpdaterU;
{$IfDef Debug}
  {$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V-,W-,X+,Y+,Z1}
{$Else}
  {$A+,B-,C-,D-,E-,F-,G-,H+,I+,J+,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T+,U-,V-,W-,X+,Y-,Z1}
{$EndIf}
{<< Mads Lundwall 2002 >>}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, DirTransversor, ComCtrls, Buttons;

type
  TOpForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    DrevFra: TDriveComboBox;
    DirFra: TDirectoryListBox;
    DirTrans: TDirTransver;
    TabSheet2: TTabSheet;
    Spoerg: TCheckBox;
    OpretDir: TCheckBox;
    OpretHvadIkkeFindes: TCheckBox;
    TabSheet3: TTabSheet;
    DirTil: TDirectoryListBox;
    DrevTil: TDriveComboBox;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    Maske: TFilterComboBox;
    Fra: TLabel;
    Label2: TLabel;
    Til: TLabel;
    Label3: TLabel;
    Tilbage: TCheckBox;
    TilDirEditor: TEdit;
    KunUnderMapper: TCheckBox;
    VisKunAendringer: TCheckBox;
    SletFraA: TCheckBox;
    VisOpdat: TButton;
    Procedure OpdaterKnapClick(SEnder: TObject);
    procedure VisOpdatClick(Sender: TObject);
    Procedure MaskeChange(SEnder: TObject);
    Procedure DirFraClick(SEnder: TObject);
    Procedure DirTilClick(SEnder: TObject);
    Procedure DirTilChange(SEnder: TObject);
    Procedure TilDirEditorChange(SEnder: TObject);
    Procedure FormClose(SEnder: TObject; var Action: TCloseAction);
  private
    Procedure Opdater(f,t : String;GoerDet : Boolean);
    Procedure Kopier(f,t : String);
    Procedure GemIndstil;
  public
    Procedure Init;
    Procedure Stop;
  End;

var
  OpForm  : TOpForm;
  UdFoer  : Boolean;
  FraSti,
  TilSti  : String;

Implementation

Uses
  Util,
  Registry,
  ListeU,
  SpoergDlgUnit,
  FejlDlgUnit;

ResourceString
  AppKey   = 'Lundwall\Opdater';
  OpretS   = 'Opret ';
  OpdaterS = 'Opdater ';

{$R *.DFM}


  Procedure TOpForm.Kopier(f,t : String);
  Const
    BufLen   = $E0000;

    Procedure SaetTid(f,t : Word); {FraRec.Handle,TilRec.Handle}
    Var
      SidstAendret : PFileTime;
      // FILETIME er en 64-bit vrdi = Antallet af 100 nanosekunder siden 1. januar 1601
    Begin
      New(SidstAendret);
      GetFileTime(f,Nil,Nil,SidstAendret);
      SetFileTime(t,Nil,Nil,SidstAendret);
      Dispose(SidstAendret)
    End;

  Var
    Fra, Til : File;
    Count    : Integer;
    Buf      : Array[0..Pred(BufLen)] Of Byte;
    Fejl     : Boolean;
    FraRec   : TFileRec Absolute Fra;
    TilRec   : TFileRec Absolute Til;
  Begin
    Fejl:=False;
    Try
      AssignFile(Fra,f);
      Except On EInOutError Do
      Begin
        Fejl:=True;
        FejlDlg.Vis('Kunne ikke bne '+f);
      End
    End;
    Try
      AssignFile(Til,t);
      Except On EInOutError Do
      Begin
        Fejl:=True;
        FejlDlg.Vis('Kunne ikke bne '+t);
      End
    End;
    Try
      Reset(Fra,1);
      Rewrite(Til,1);
      While Not Eof(Fra) Do
      Begin
        BlockRead(Fra,Buf,BufLen,Count);
        BlockWrite(Til,Buf,Count);
      End
      Except On EInOutError Do
      Begin
        Fejl:=True;
        FejlDlg.Vis('Fejl ved kopiering af '+ExtractFileName(t)+'. Disk fuld?');
      End
    End;
    IOResult;
    SaetTid(FraRec.Handle,TilRec.Handle);
    Try
      CloseFile(Til);
      Except On EInOutError Do
        FejlDlg.Vis('Kunne ikke lukke '+t)
    End;
    Try
      CloseFile(Fra);
      Except On EInOutError Do
        ;
    End;
    If Fejl Then
    Try
      AssignFile(Til,t);
      Erase(Til);
      Except On EInOutError Do
        ;
    End;
  End;

  Function Behandl(Fra : String) : Boolean; Far;
  Var
    Til   : String;
    Tekst : String;
  Label
    Ud;

    Procedure Slet(FN : String);
    Var
      Fil : File;
    Begin
      Assign(Fil,FN);
      Erase(Fil)
    End;

  Begin
    If Udfoer Then
      Liste.Caption:='Opdaterer'
    Else
      Liste.Caption:='Viser opdateringsbehov (udfrer ikke)';
    Behandl:=Not OpForm.DirTrans.Stop;
    Application.ProcessMessages;
    Til:=TilSti+Copy(Fra,Length(FraSti)+1,Length(Fra));
    If Not DirExists(ExtractFileDir(Til)) Then
      If Not OpForm.OpretDir.Checked Then
        Goto Ud
      Else
        ForceDirectories(ExtractFileDir(Til));
    If Not FileExists(Til) Then
      If Not OpForm.OpretHvadIkkeFindes.Checked Then
        Goto Ud
      Else
        Tekst:=OpretS
    Else
      Tekst:=OpdaterS;
    If (Not FileExists(Til)) Or (FileAge(Fra)>FileAge(Til)) Then
    Begin
      If OpForm.Spoerg.Checked And (Not SpoergDlg.Ask(Tekst+ExtractFileName(Til))) Then
        Goto Ud;
      Liste.Tilfoej(ExtractFileName(Fra)+' -> '+ExtractFileDir(Til));
      If Udfoer Then OpForm.Kopier(Fra,Til);
      If OpForm.SletFraA.Checked And (Fra[1]='A') Then
        If Udfoer Then Slet(Fra);
      Exit;
    End
    Else
      If OpForm.Tilbage.Checked And (FileAge(Fra)<FileAge(Til)) Then
      Begin
        If OpForm.Spoerg.Checked And (Not SpoergDlg.Ask(Tekst+ExtractFileName(Fra))) Then
          Goto Ud;
        Liste.Tilfoej(ExtractFileName(Fra)+' <- '+ExtractFileDir(Til));
        If UdFoer Then OpForm.Kopier(Til,Fra);
        If OpForm.SletFraA.Checked And (Til[1]='A') Then
          If Udfoer Then Slet(Til);
        Exit;
      End;
  Ud:
    Behandl:=Not OpForm.DirTrans.Stop;
    If Not OpForm.VisKunAendringer.Checked Then
      Liste.Tilfoej(ExtractFileName(Fra)+' Undret');
  End;

  Procedure TOpForm.Opdater(f,t : String; GoerDet : Boolean);
  Begin
    Udfoer:=GoerDet;
    Liste.Show;
    Liste.Clear;
    Liste.StopKnap.Enabled:=True;
    TilSti:=Util.TilSti(t);
    FraSti:=Util.TilSti(f);
    DirTrans.RodDir:=f;
    DirTrans.SaetBF(Behandl);
    DirTrans.Koer(KunUnderMapper.Checked);
    Liste.StopKnap.Enabled:=False;
    Self.Show;
    GemIndstil;
    BringToFront
  End;

  Procedure TOpForm.GemIndstil;
  Var
    Reg : TRegistry;
  Begin
    Reg:=Tregistry.Create;
    Try
      Reg.OpenKey(AppKey,True);
      Try
        Reg.WriteString('FraDir',DirFra.Directory);
        Reg.WriteString('TilDir',TilDirEditor.Text);
        Reg.WriteBool('Spoerg',Spoerg.Checked);
        Reg.WriteBool('OpretDir',OpretDir.Checked);
        Reg.WriteBool('OpretFiler',OpretHvadIkkeFindes.Checked);
        Reg.WriteBool('Tilbage',TilBage.Checked);
        Reg.WriteInteger('Maske',Maske.ItemIndex);
        Reg.WriteBool('KunUndermapper',KunUnderMapper.Checked);
        Reg.WriteBool('VisKunAendringer',VisKunAendringer.Checked);
        Reg.WriteBool('SletFraA',SletFraA.Checked);
        Reg.CloseKey;
        Except On Exception Do
          ;
      End;
      Finally
        Reg.Destroy;
    End
  End;

  Procedure TOpForm.OpdaterKnapClick(SEnder: TObject);
  Begin
    If Util.TilSti(DirFra.Directory)<>Util.TilSti(TilDirEditor.Text) Then
      Opdater(DirFra.Directory,TilDirEditor.Text,True)
    Else
      FejlDlg.Vis('Fra og til identisk!');
  End;


  Procedure TOpForm.VisOpdatClick(Sender: TObject);
  Begin
    If Util.TilSti(DirFra.Directory)<>Util.TilSti(TilDirEditor.Text) Then
      Opdater(DirFra.Directory,TilDirEditor.Text,False)
    Else
      FejlDlg.Vis('Fra og til identisk!');
  End;

  Procedure TOpForm.Init;
  Var
    Fejl : Boolean;
    Reg  : TRegistry;
    f,t  : String;

    Procedure SaetFra(d : String);
    Var
      i      : Word;
      Findes : Boolean;
    Const
      StrN   = 24;
      DelStr : Array [0..Pred(StrN)] Of String = (
        'C:\Arb\Delphi\Projects',
        'D:\Arb\Delphi\Projects',
        'C:\Arb\Delphi5\Projects',
        'D:\Arb\Delphi5\Projects',
        'C:\Programmer\Delphi\Projects',
        'D:\Programmer\Delphi\Projects',
        'C:\Programmer\Delphi5\Projects',
        'D:\Arb\Borland\Delphi\Projects',
        'C:\Arb\Borland\Delphi\Projects',
        'D:\Programmer\Delphi5\Projects',
        'C:\Arb\Borland\Delphi5\Projects',
        'D:\Arb\Borland\Delphi5\Projects',
        'C:\Program Files\Delphi\Projects',
        'D:\Program Files\Delphi\Projects',
        'C:\Program Files\Delphi5\Projects',
        'D:\Program Files\Delphi5\Projects',
        'C:\Programmer\Borland\Delphi\Projects',
        'D:\Programmer\Borland\Delphi\Projects',
        'C:\Programmer\Borland\Delphi5\Projects',
        'D:\Programmer\Borland\Delphi5\Projects',
        'C:\Program Files\Borland\Delphi\Projects',
        'D:\Program Files\Borland\Delphi\Projects',
        'C:\Program Files\Borland\Delphi5\Projects',
        'D:\Program Files\Borland\Delphi5\Projects'
        );
    Begin
      If (d='') Or (UpperCase(d)='C:\') Or (Not DirectoryExists(d)) Then
      Begin
        Findes:=False;
        i:=0;
        Try
          While (Not Findes) And (i<StrN) Do
          Begin
            Findes:=DirectoryExists(DelStr[i]);
            If Not Findes Then
              Inc(i);
          End;
          Except On Exception Do
            d:='C:\';
        End;
        If Findes Then
          d:=DelStr[i]
        Else
          d:='C:\';
      End;
      Try
        DirFra.Directory:=d;
        Except On Exception Do
          ;
      End
    End;

    Procedure SaetTil(d : String);
    Var
      i      : Word;
      Findes : Boolean;
    Const
      StrN = 4;
      DelStr : Array [0..Pred(StrN)] Of String = (
        'C:\Windows\Skrivebord',
        'C:\Windows\Desktop',
        'A:\',
        'B:\'
        );
    Begin
      If (d='') Or (Not DirectoryExists(d)) Then
      Begin
        Findes:=False;
        i:=0;
        Try
          While (Not Findes) And (i<StrN) Do
          Begin
            Findes:=DirectoryExists(DelStr[i]);
            If Not Findes Then
              Inc(i);
          End;
          Except On Exception Do
            d:='C:\';
        End;
        If Findes Then
          d:=DelStr[i]
        Else
          d:='C:\';
      End;
      Try
        DirTil.Directory:=d;
        Except On Exception Do
          ;
      End
    End;

  Begin
    Fejl:=False;
    DirTrans.Maske:=Maske.Mask;
    If ParamCount=2 Then
    Begin
      Try
        DirFra.Directory:=ParamStr(1);
        DirTil.Directory:=ParamStr(2);
        If Not DirExists(DirFra.Directory) Then
        Begin
          FejlDlg.Vis('Fra-dir ikke fundet');
          Halt
        End;
        Except On Exception Do
        Begin
          Fejl:=True;
          FejlDlg.Vis('Fejl i sti-parametre')
        End;
      End;
      If Not Fejl Then
      Begin
        Hide;
        OpdaterKnapClick(Nil)
      End;
      Halt
    End
    Else
    Begin
      If ParamCount=0 Then
      Begin
        Reg:=TRegistry.Create;
        Try
          Try
            Reg.OpenKey(AppKey,True);
            f:=Reg.ReadString('FraDir');
            t:=Reg.ReadString('TilDir');
            Spoerg.Checked:=Reg.ReadBool('Spoerg');
            OpretDir.Checked:=Reg.ReadBool('OpretDir');
            OpretHvadIkkeFindes.Checked:=Reg.ReadBool('OpretFiler');
            TilBage.Checked:=Reg.ReadBool('Tilbage');
            Maske.ItemIndex:=Reg.ReadInteger('Maske');
            KunUnderMapper.Checked:=Reg.ReadBool('KunUndermapper');
            VisKunAendringer.Checked:=Reg.ReadBool('VisKunAendringer');
            SletFraA.Checked:=Reg.ReadBool('SletFraA');
            Reg.CloseKey;
            Except On E: Exception Do
              GemIndstil
          End;
          Finally
            Reg.Destroy;
        End;
        SaetTil(t);
        SaetFra(f)
      End
      Else
      Begin
        FejlDlg.Vis('Angiv to sti-parametre adskilt af mellemrum');
        Halt
      End
    End
  End;

  Procedure TOpForm.Stop;
  Begin
    DirTrans.Stop:=True;
  End;

  Procedure TOpForm.MaskeChange(SEnder: TObject);
  Begin
    DirTrans.Maske:=Maske.Mask
  End;

  Procedure TOpForm.DirFraClick(SEnder: TObject);
  Begin
    DirFra.Directory:=DirFra.GetItemPath(DirFra.ItemIndex);
    Fra.Caption:=DirFra.Directory
  End;

  Procedure TOpForm.DirTilClick(SEnder: TObject);
  Begin
    DirTil.Directory:=DirTil.GetItemPath(DirTil.ItemIndex);
    Til.Caption:=DirTil.Directory
  End;

  Procedure TOpForm.DirTilChange(SEnder: TObject);
  Begin
    TilDirEditor.Text:=DirTil.Directory
  End;

  Procedure TOpForm.TilDirEditorChange(SEnder: TObject);
  Begin
    Til.Caption:=TilDirEditor.Text
  End;

  Procedure TOpForm.FormClose(SEnder: TObject; var Action: TCloseAction);
  Begin
    GemIndstil
  End;

End.
