unit OpdaterU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, uoole, FileCtrl, ComCtrls;

type
  T_Opdater = class(TForm)
    Sidevaelg: TPageControl;
    DrevFra: TDriveComboBox;
    DirFra: TDirectoryListBox;
    FilListeFra: TFileListBox;
    Fra: TTabSheet;
    Til: TTabSheet;
    DrevTil: TDriveComboBox;
    DirTil: TDirectoryListBox;
    FilListeTil: TFileListBox;
    ValgtTil: TListBox;
    ValgtFra: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    OpdaterKnap: TButton;
    procedure ValgtFraDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ValgtFraDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FilListeFraDblClick(Sender: TObject);
    procedure DirFraDblClick(Sender: TObject);
    procedure ValgtFraKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ValgtTilDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ValgtTilDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FilListeTilDblClick(Sender: TObject);
    procedure DirTilDblClick(Sender: TObject);
    procedure ValgtTilKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OpdaterKnapClick(Sender: TObject);
  private    { Private declarations }
  Procedure T_Opdater.ValgtFraDragOver(Sender, Source: TObject; X, Y: Integer;
    State: TDragState; var Accept: Boolean);
  Begin
    Accept:=True;
  End;

  Procedure T_Opdater.ValgtFraDragDrop(Sender, Source: TObject; X, Y: Integer);
  Var
    FilListeFra : TFileListBox;
    i           : Integer;
  Begin
    If Source is TFileListBox Then
    Begin
      FilListeFra:=TFileListBox(Source);
      For i:=1 To FilListeFra.Items.Count Do
        If FilListeFra.Selected[i-1] Then
          TilValgtFra(DrevFra.Drive+':'+FjernSlash(DirFra.Directory)+'\'+FilListeFra.Items[i-1])
    End
    Else
      TilValgtFra(DrevFra.Drive+':'+FjernSlash(DirFra.Directory)+'\*.*');
  End;

  Procedure T_Opdater.FilListeFraDblClick(Sender: TObject);
  Var
    i : Integer;
  Begin
    For i:=1 To FilListeFra.Items.Count Do
      If FilListeFra.Selected[i-1] Then
        TilValgtFra(DrevFra.Drive+':'+FjernSlash(DirFra.Directory)+'\'+FilListeFra.Items[i-1])
  End;

  Procedure T_Opdater.TilValgtFra(s : String);
  Var
    i      : Integer;
    Findes : Boolean;
  Begin
    i:=0;
    Findes:=False;
    While Not Findes And (i<ValgtFra.Items.Count) Do
    Begin
      If ValgtFra.Items[i]=s Then
        Findes:=True;
      Inc(i);
    End;
    If Not Findes Then
      ValgtFra.Items.Add(s);
  End;

  procedure T_Opdater.DirFraDblClick(Sender: TObject);
  Begin
     TilValgtFra(DrevFra.Drive+':'+FjernSlash(DirFra.Directory)+'\*.*')
  end;

  procedure T_Opdater.ValgtFraKeyUp(Sender: TObject; var Key: Word;
    Shift: TShiftState);
  Var
    i      : Integer;
  begin
    If Key=46 { Del } Then
      For i:=1 To ValgtFra.Items.Count Do
        If ValgtFra.Selected[i-1] Then
          ValgtFra.Items.Delete(i-1)
  end;

  Procedure T_Opdater.ValgtTilDragOver(Sender, Source: TObject; X, Y: Integer;
    State: TDragState; var Accept: Boolean);
  Begin
    Accept:=True;
  End;

  Procedure T_Opdater.ValgtTilDragDrop(Sender, Source: TObject; X, Y: Integer);
  Var
    FilListeTil : TFileListBox;
    i           : Integer;
  Begin
    If Source is TFileListBox Then
    Begin
      FilListeTil:=TFileListBox(Source);
      For i:=1 To FilListeTil.Items.Count Do
        If FilListeTil.Selected[i-1] Then
          TilValgtTil(DrevTil.Drive+':'+FjernSlash(DirTil.Directory)+'\'+FilListeTil.Items[i-1])
    End
    Else
      TilValgtTil(DrevTil.Drive+':'+FjernSlash(DirTil.Directory)+'\*.*');
  End;

  Procedure T_Opdater.FilListeTilDblClick(Sender: TObject);
  Var
    i : Integer;
  Begin
    For i:=1 To FilListeTil.Items.Count Do
      If FilListeTil.Selected[i-1] Then
        TilValgtTil(DrevTil.Drive+':'+FjernSlash(DirTil.Directory)+'\'+FilListeTil.Items[i-1])
  End;

  Procedure T_Opdater.TilValgtTil(s : String);
  Var
    i      : Integer;
    Findes : Boolean;
  Begin
    i:=0;
    Findes:=False;
    While Not Findes And (i<ValgtTil.Items.Count) Do
    Begin
      If ValgtTil.Items[i]=s Then
        Findes:=True;
      Inc(i);
    End;
    If Not Findes Then
      ValgtTil.Items.Add(s);
  End;

  procedure T_Opdater.DirTilDblClick(Sender: TObject);
  Begin
     TilValgtTil(DrevTil.Drive+':'+FjernSlash(DirTil.Directory)+'\*.*')
  end;

  procedure T_Opdater.ValgtTilKeyUp(Sender: TObject; var Key: Word;
    Shift: TShiftState);
  Var
    i      : Integer;
  begin
    If Key=46 { Del } Then
      For i:=1 To ValgtTil.Items.Count Do
        If ValgtTil.Selected[i-1] Then
          ValgtTil.Items.Delete(i-1)
  end;

End.
